% *************************************************************
% author:   Gene Cheung                                      **
% date:     07/23/2014                                       **
% modified: 07/23/2014                                       **
% purpose:  convert a contour to chain code (length-1)       **
% *************************************************************

function [chain] = contour2chain (contour)

ind = find(contour == 0);
len = ind(1);
chain = [];

% there is edge not accounted for ********
for i = 2:len-1,
    
    if contour(i) == contour (i-1),          % same direction == straight
        chain = [chain 0];
    elseif contour(i) - contour(i-1) == 1,   % right
        chain = [chain 1];
    elseif contour(i) - contour(i-1) == -1,  % left
        chain = [chain 2];
    elseif contour(i) - contour(i-1) == -3,  % right: west to north
        chain = [chain 1];
    elseif contour(i) - contour(i-1) == 3,   % left: north to west
        chain = [chain 2];
    end
   
end