% ************************************************************************
% author:   Amin Zheng                                                  **
% date:     06/23/2015                                                  **
% modified: 07/25/2015                                                  **
%           add the MAP method                                          **
% purpose:  get the pruned tree                                         **
% ************************************************************************

function [treeHeight, maxOrder, orgTreeHeight, prunedSizeMaxOrder] = pruningMCT(countStateSpace, method, alphaPrune)

[orderRange, spaceSize, ~] = size(countStateSpace);
treeHeight = zeros(orderRange, spaceSize);
prunedSize = zeros(orderRange, 1);
orgTreeHeight = [];

if strcmp(method, 'CT-LL') == 1  
    [treeHeight, prunedSize, orgTreeHeight] = pruningMAP(countStateSpace, orderRange, alphaPrune);
end

% get the maxOrder: maximum depth of context tree ****
maxOrder = max(treeHeight(:));

prunedSizeMaxOrder = prunedSize(maxOrder);

end